﻿package {
	//Aquí importanmos los paquetes de clases que necesitamos utilizar en la aplicación
	import flash.display.*;
	import flash.events.*;
	import flash.utils.*;
	import flash.net.*;
	import flash.ui.*;
	import flash.text.*
	import flash.filters.BlurFilter;
	import flash.media.*;
	import flash.geom.Rectangle;
	//Este es el nombre de la clase, el cual deberá ser igual al nombre del archivo "PreloadCircle.as"
	public class PiePreloader {
		//Defino las variables que necesito para componer la precarga
		private var container:MovieClip; //Clip contenedor
		private var type; //Elemento que voy a precargar
		private var root:MovieClip; //Ruta dónde insertaré el contenedor con la precarga
		private var clipfront:MovieClip;//Círculo que será enmascarado
		private var clipback:MovieClip;//Círculo de fondo
		private var masc:MovieClip;//Máscara
		private var angle:Number;//Angulo de dibujo de la máscara
		private var centerx:Number;//Centro x de la torta
		private var centery:Number;//Centro y de la torta
		private var radio:Number;//Radio de la torta
		private var status:Boolean;//Estado de la rotación
		private var cargados:Number;
		private var totales:Number;
		public var theend:Function;//Defino la función que se ejecutará cuando finalice la carga
		
		//Función constructora del preload
		public function PiePreloader(root:MovieClip,type,clipfront:MovieClip,clipback:MovieClip,centerx:Number,centery:Number,status:Boolean){
			//Asignación de valores a las variables
			this.root = root;
			this.angle = 0;
			this.status = status;
			
			this.container = new MovieClip();
			this.root.addChild(this.container);
			this.container.x = centerx;
			this.container.y = centery;
			
			this.clipback = clipback;
			this.container.addChild(this.clipback);
			this.clipback.x = 0;
			this.clipback.y = 0;
			
			this.clipfront = clipfront;
			this.container.addChild(this.clipfront);
			this.clipfront.x = 0;
			this.clipfront.y = 0;
			
			this.radio = this.clipfront.width/2 + 10;
			
			this.masc = new MovieClip();
			this.container.addChild(this.masc);
			this.masc.x = 0 - (this.clipfront.width/2);
			this.masc.y = 0 - (this.clipfront.height/2);
			
			this.centerx = this.clipfront.width/2;
			this.centery = this.clipfront.height/2;
			
			this.clipfront.mask = this.masc;
			
			this.type = type;
			//Si el elemento es un XML, creo una instancia de la clase Loader de Flash
			if(typeof this.type == "string"){
				var loader:URLLoader = new URLLoader();
				var request:URLRequest = new URLRequest(this.type);
				loader.load(request);
				this.setPreloader(loader);
				//Sino ejecuto directamente la función setPreloader
			}else if(typeof this.type == "object"){
				this.setPreloader(this.type);
			}
		}
		//En esta función se define cuál es el elemento a precargar y se ejecuta la funición Enter Frame que efectúa dicha percarga
		private function setPreloader(element):void{
			this.type = element;
			this.container.addEventListener(Event.ENTER_FRAME,onLoadElement);
		}
		
		private function onLoadElement(e:Event):void{
			//Si el elemento es un movie clip, defino las variables cargados y totales con las propiedades del MovieClip
			if(this.type == "[object MovieClip]"){
				this.cargados = this.type.framesLoaded;
				this.totales = this.type.totalFrames;
			//De lo contrario, igualo con otras propiedades si es un xml o la película principal.
			}else{
				this.cargados = this.type.bytesLoaded;
				this.totales = this.type.bytesTotal;
			}
			//Si ya ha cargado y la torta se ha completado, escalo la precarga hasta que desaparesca y ejecuto la función "theend"
			if(this.cargados >= this.totales && this.angle >= 360){
				this.clipfront.scaleX = this.clipfront.scaleY-= 0.1;
				this.clipback.scaleX = this.clipback.scaleY-= 0.1;
				if(this.clipfront.scaleX <= 0.01){
					this.container.removeEventListener(Event.ENTER_FRAME,onLoadElement);
					this.root.removeChild(this.container);
					this.theend();
				}
			}
			//Incremento el ángulo y calculo los valores para dibujar luego la máscara.
			this.calculateAngle();
		}
		
		//esta función me hace los cálculos trigonométicos para luego deibujar la máscara que irá mostrando la torta
		private function calculateAngle():void{
			var estado = (this.cargados / this.totales) * 360;
			if(estado > this.angle){
				this.angle+= 5;
			}
			if(this.status){
				this.clipfront.rotation+= 10;
				this.clipback.rotation+= 10;
			}
			var radianes1 = (Math.PI * (this.angle - 5)) / 180;
			var pos1x = Math.cos(radianes1) * this.radio;
			var pos1y = Math.sin(radianes1) * this.radio;
			
			var radianes2 = (Math.PI * this.angle) / 180;
			var pos2x = Math.cos(radianes2) * this.radio;
			var pos2y = Math.sin(radianes2) * this.radio;
			//Una vez obtenidos los valores, ejecuto la función que dibuja la máscara
			this.drawCircle(this.masc,pos1x,pos1y,pos2x,pos2y);
		}
		//Con esta función voy dibujando triángulos contiguos que me permiten completar el círculo de la torta.
		private function drawCircle(clip,pos1x,pos1y,pos2x,pos2y):void{
			clip.graphics.beginFill(0xFF0000);
			clip.graphics.moveTo(this.centerx,this.centery);
			clip.graphics.lineTo(this.centerx + pos1x, this.centery + pos1y);
			clip.graphics.lineTo(this.centerx + pos2x, this.centery + pos2y);
			clip.graphics.lineTo(this.centerx,this.centery);
			clip.graphics.endFill();
		}
	}
}